//*******************************************************
//
//	VS1011 + MMC/SD MP3 Player BK1
//
//	MCU:ATmega168
//		efuse:0xF9
//		hfuse:0xD6	BOD 1.8V EEPROMی
//		lfuse:0xE2	CRU 8MHz
//
//	Compiler:	AVR-GCC		3.4.6
//				AVR-LIBC	1.4.2
//				binutils	2.16.1
//
//	2007.4.10	X[v^C}ԂɂȂȂsC
//				play_music_callback()̌Ăяo 20msƂɕύX
//	2007.4.9	Tiny-FatFs̗p
//				MP1BK1.CNFt@Cݒlǂݍ
//	2007.3.27	KAWAKAMI Yukio
//
//	New BSD license
//*******************************************************

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/pgmspace.h>
#include	<stdlib.h>
#include	<string.h>

#include	"integer.h"
#include	"diskio.h"
#include	"tff.h"

#include	"BK1.h"

#define		CONFIG_FILE	"MP3BK1.CNF"	// ݒt@C

#define	PLAY_MUSIC_CALLBACK_TIMER	2	// 20ms

#define	MMC_WAIT	50					// ő 0.5b

#define		BEEP_VOL_DIFF	0x18	// BEEP̃{[ʏ艺
#define		VOLUME_DEFAULT	0x40	// ftHg{[

// eXgpAgo̓f[^		BeepƂĎg
PROGMEM uchar BeepData[] = { 0x53, 0xEF, 0x6E, 0xF0, 0, 0, 0, 0 };	// 1500Hz
PROGMEM uchar ErrorBeep[] = { 0x53, 0xEF, 0x6E, 0xA4, 0, 0, 0, 0 };	// 500Hz
PROGMEM uchar BeepStop[] = { 0x45, 0x78, 0x69, 0x74, 0, 0, 0, 0 };	// ~߂

FATFS	FatFs;
FIL		Mp3File;

ulong	MusicP;		// Đ̋Ȃ̃|C^
uint	PlayMusic;	// Đ̋Ȕԍ
ulong	MusicSize;	// Đ̋Ȃ̃TCY
uint	MusicCount;	// J[h̋Ȑ

volatile uchar	MMCtimer;		// MMCǂݏ^CAEg^C}

volatile uchar	Volume;			// 
volatile uchar	VolumeReg;		// ݂̎ۂ̉ʐݒl
volatile uchar	FadeInVol;		// tF[hC{[
volatile uint	BattVolt;		// ^C}[荞݂Ŏ擾dd
volatile uchar	SwitchFlag;		// ^C}[荞݂Ŏ擾XCb`̏
volatile uchar	BeepTimer;		// Beep̒

volatile uchar	StopSw;		// START/STOPXCb`̓tO
volatile uchar	RewSw;		// REWXCb`̓tO
volatile uchar	FfSw;		// FFXCb`̓tO
volatile uchar	VolUpSw;	// Vol upXCb`̓tO
volatile uchar	VolDownSw;	// Vol downXCb`̓tO
volatile uchar	Timer;		// ėp^C}
volatile uchar	FlushTimer;	// LED_Ń^C}

volatile uchar	RunningTimeDS;	// ғ(1/100b)
volatile uchar	RunningTimeS;	//     V  (b)

volatile uchar	SleepCounter;		// X[vJE^()
volatile uchar	SleepFlag;		// X[v^C}tO

uchar SleepTime;		// X[v^C}()
ulong VSclock;			// VS1011eNbN
uint BattLowAlerm;		// dxl
uint BattLowShutDown;	// dVbg_El

char	Debug;			// fobOtO


//*********************************
//	^C}[Qrv荞
//	8MHz/1024/78100Hz
//*********************************
ISR(TIMER2_COMPA_vect){
	uchar	old_sw;

	if (Timer)		--Timer;		// ėp^C}
	if (BeepTimer)	--BeepTimer;	// Beep^C}
	if (MMCtimer)	--MMCtimer;		// MMCǂݏ^C}

	// [obe[oɂ_
	if (++FlushTimer >= 100){
		if (BattVolt < BattLowAlerm){
			DDRD &= ~(1<<LED);	// LED OFF
		}
		FlushTimer = 0;
	} else if (FlushTimer == 50){
		DDRD |= (1<<LED);		// LED ON
	}

	// ғԋL^
	if (++RunningTimeDS >= 100){
		RunningTimeDS = 0;
		if (++RunningTimeS >= 60){
			RunningTimeS = 0;
			// X[v^C}
			if (SleepFlag){
				if (SleepCounter < SleepTime){
					SleepCounter++;
				}
			}
		}
	}

	// XCb``FbN
	old_sw = SwitchFlag;
	SwitchFlag = 0;
	if (!(PIND & (1<<SW_PORT_STOP))){
		if (old_sw & (1<<SW_STOP)){
			if (++StopSw == 0)	StopSw = 255;
		} else {
			StopSw = 1;
		}
		SwitchFlag = (1<<SW_STOP);
	}

	if (!(PIND & (1<<SW_PORT_REW))){
		if (old_sw & (1<<SW_REW)){
			if (++RewSw == 0)	RewSw = 255;
		} else {
			RewSw = 1;
		}
		SwitchFlag |= (1<<SW_REW);
	}

	if (!(PIND & (1<<SW_PORT_VOLDOWN))){
		if (++VolDownSw == 0)	VolDownSw = 255;
		if (VolDownSw >= 20){
			Volume += 8;
			if (Volume >= 0xB8)	Volume = 0xB0;
			VolDownSw = 1;
		}
		SwitchFlag |= (1<<SW_VOLDOWN);
	} else {
		VolDownSw = 0;
	}

	if (!(PIND & (1<<SW_PORT_VOLUP))){
		if (++VolUpSw == 0)	VolUpSw = 255;
		if (VolUpSw >= 20){
			Volume -= 8;
			if (Volume >= 0xF8)	Volume = 0x00;
			VolUpSw = 1;
		}
		SwitchFlag |= (1<<SW_VOLUP);
	} else {
		VolUpSw = 0;
	}

	// tF[hC{[
	if (FadeInVol){
		if (FadeInVol >= 4){
			Volume -= 4;
		} else {
			Volume = FadeInVol;
		}
		if (Volume <= FadeInVol)	FadeInVol = 0;
	}

	// A/DϊJn vXP[ 8MHz/64 = 125kHz
	ADCSRA = (1<<ADEN)|(1<<ADSC)|(1<<ADIE)|(1<<ADPS1)|(1<<ADPS2);
}


//*********************************
//	A/Dϊ̊荞݃[`
//*********************************
ISR(ADC_vect) {

	// A/Dϊʊi[
	// ADCL  ADCH ̏ɃANZXKv
	BattVolt = (uint)ADCL;
	BattVolt |= (((uint)ADCH & 3) << 8);
}


//*********************************
//	sω荞݃[`
//*********************************
ISR(PCINT1_vect) {
	// CPUN
	;
}


//*********************************
//	C[`
//*********************************
int main (void) {
	uchar	ret;
	uchar	start_volume;

	cli();
	PORTB = (1<<PB7)|(1<<PB6)|(1<<MMC_CS)|(1<<MMC_MOSI)|(1<<MMC_SCK)|(1<<MP3_CTRL_CS)|(1<<MP3_DATA_CS);
	DDRB = (1<<MMC_SCK)|(1<<MMC_CS)|(1<<MMC_MOSI)|(1<<MP3_CTRL_CS)|(1<<MP3_DATA_CS);

	PORTC = (1<<SCL)|(1<<SDA);
	DDRC = (1<<POWER)|(1<<MP3_RESET);

	PORTD = (1<<SW_PORT_START)|(1<<SW_PORT_REW)|(1<<SW_PORT_VOLUP)|(1<<SW_PORT_VOLDOWN)|(1<<ROM_CS)|(1<<TXD)|(1<<RXD);
	DDRD = (1<<LED);

	if (MCUSR & (1<<WDRF)){
		// EHb`hbOZbg
		shutdown(1);	// Vbg_E
	}
	MCUSR = 0;

	WDR;
	WDTCSR = (1<<WDCE)|(1<<WDE);	// WDCEWDE1ɂă^C}[ύX
	WDTCSR = (1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0);	// EHb`hbO^C}[Zbg Qb

	ADMUX = (1<<REFS1)|(1<<REFS0)|BATT_VOLT;	// d 1.1V, A/D ch
	ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);	// A/DϊHON vXP[ 8MHz/64 = 125kHz

	TCCR2A = (1<<WGM21);					// CTC
	TCCR2B = (1<<CS22)|(1<<CS21)|(1<<CS20);	// vXP[ 1/1024
	OCR2A = 78 - 1;			// ^C}JEgől  8MHz/1024/78100Hz
	TIMSK2 = (1<<OCIE2A);	// r`荞݋

	SMCR = (1<<SE);			// X[v ACh[h

	// TWI, TIMER0, TIMER1, USART d̓Jbg
	PRR = (1<<PRTWI)|(1<<PRTIM0)|(1<<PRTIM1)|(1<<PRUSART0);
	ACSR = (1<<ACD);			// AiORp[^֎~

	PCMSK1 = (1<<PCINT9);	// PCINT9(DREQ)荞݃}XN
	PCICR = (1<<PCIE1);		// sω荞݂P
	
	SwitchFlag = 0;
	VolumeReg = 0xFF;
	FlushTimer = 0;
	SleepCounter = 0;
	SleepFlag = 0;

	// ғ
	RunningTimeDS = 0;
	RunningTimeS = 0;

	sei();		// 荞݋

	PORTC |= (1<<POWER);	// POWERێ
	PORTD |= (1<<LED);		// LED_

	// VS1011Zbg
	VS_RESET_OFF;

	// 肷܂ 0.1b҂
	Timer = 10;
	while(Timer)	SLEEP;

	WDR;
	Timer = 20;	//  0.2b

	// 
	Volume = read_eeprom(EEPROM_VOLUME);
	if ((Volume & 7) == 7)	Volume = VOLUME_DEFAULT;
	start_volume = Volume;

	// {[DOWNȂNftHg{[ɂǂ
	if (SwitchFlag & (1<<SW_VOLDOWN)){
		start_volume = Volume = VOLUME_DEFAULT;
	}

	// J[h}Eg
	ret = f_mount(0, &FatFs);

	WDR;

	// eݒlǂݍ
	load_conf();

	// {[UPȂNX[v
	if (SleepTime && (SwitchFlag & (1<<SW_VOLUP))){
		SleepFlag = 1;
	}

	// VS1011e 
	MP3_init();

	// 0.2b҂
	while(Timer)	SLEEP;

	if (ret != FR_OK){	// G[
		beep(3, BEEP_LOW);
		shutdown(1);	// Vbg_E
	} else if (SleepFlag){
		beep(2, BEEP_HIGH);	// X[v[h
	} else {
		beep(1, BEEP_HIGH);	// BEEP
	}

	// EEPROMOĐĂȏ擾
	PlayMusic = read_eeprom(EEPROM_MUSIC);
	MusicP = read_eeprom_long(EEPROM_MUSIC_P);
	MusicSize = read_eeprom_long(EEPROM_SIZE);

	// J[h̋ȐmF
	{
		FILINFO	file;
		MusicCount = search_MP3(0xFFFF, &file);
	}

	if (MusicCount == 0){
		// MP3t@C
		beep(1, BEEP_LOW);
		shutdown(1);	// Vbg_E
	}

	if (PlayMusic == 0)	PlayMusic = 1;

	// MMC/SDJ[hꂽǂׂ
	{
		FILINFO	file;
		search_MP3(PlayMusic, &file);
		if (MusicSize != file.fsize){
			// tȂ̃TCYقȂĂΌꂽƂ݂Ȃ
			PlayMusic = 1;
			MusicP = 0;
		}
	}

	for(;;){
		char	r;

		if (PlayMusic > MusicCount)	PlayMusic = 1;

		switch_wait();		// XCb`܂ő҂
		if (start_volume){
			// N Vol.UP/DOWNȂNꍇ̉ʕ␳
			Volume = start_volume;
			set_volume(Volume);
			start_volume = 0;
		}

		// Đ
		r = play_music(PlayMusic, MusicP);

		switch_wait();		// XCb`܂ő҂
		if (r < 0){
			beep(-r, BEEP_LOW);		// G[
			shutdown(0);
		} else if (r == 1){		// rSTOPꂽ
			if (StopSw > 30){	// 300msȏ̒ STOP
				shutdown(0);	// d؂
			} else {
				// Zꍇ͎̋
				PlayMusic++;
				MusicP = 0;
			}
		} else if (r == 3){		// REW
			if (RewSw > 100){	// 1bȏ͍̒ŏ̋
				PlayMusic = 1;
			} else if (RewSw > 25){	// 250msȏ̒͑Ő
				if (--PlayMusic == 0){
					PlayMusic = MusicCount;
				}
			}
			MusicP = 0;	// Ȃ̍ŏ
		} else {	// FF or ̋Ȃ̍ĐI
			PlayMusic++;	// ̋
			MusicP = 0;
		}

		// X[v^C}
		if (SleepFlag){
			if (SleepCounter >= SleepTime){
				FILINFO	file;
				// ̋Ȃ̃t@CTCY EEPROMɏ
				if (PlayMusic > MusicCount)	PlayMusic = 1;
				search_MP3(PlayMusic, &file);
				MusicSize = file.fsize;
				shutdown(0);
			}
		}

		// xdȉɂȂȊԂɌx
		if (BattVolt < BattLowAlerm){
			beep(1, BEEP_LOW);
		}
	}
}


//*********************************************************
//	play_music() ̃R[obN
//	20msɂ̊֐Ă΂
//
//	߂l  == 0	Đp
//			!= 0	r~Bplay_music()͂̒lԂ
//*********************************************************
char play_music_callback(void){

	// STOP, FF{^`FbN
	if (StopSw > 2){
		beep(1, BEEP_HIGH);
		return 1;
	} else if (FfSw > 2){
		beep(1, BEEP_HIGH);
		return 2;
	} else if (RewSw > 2){
		beep(1, BEEP_HIGH);
		return 3;
	}

	return 0;	// Đp
}


//*********************************************************
//	MP3t@C{
//	F
//		num	̐߂
//		̐ȉłĂfBNgGgSĒ׏I߂
//	߂lF
//		
//		*file	ŌɌ MP3FILINFO\̏
//*********************************************************
uint search_MP3(uint num, FILINFO *file){
	DIR		dir;
	uchar	dirname[1];
	uint	n;

	dirname[0] = 0;
	if (f_opendir(&dir, dirname) != FR_OK){
		return 0;
	}

	n = 0;
	while((f_readdir(&dir, file) == FR_OK)&&
		  (file->fname[0])){
		if ((!(file->fattrib & (AM_DIR|AM_VOL)))&&
			(strstr_P(&(file->fname[0]), PSTR(".MP3")) != NULL)){
			n++;
			if (--num == 0)	break;
		}
	}

	return n;
}


//****************************************
//	MP3t@CĐ
//	fn:			Ȕԍ
//	music_p:	ĐJnʒu
//****************************************
char play_music(uint fn, ulong music_p){
	FILINFO	file;
	uint	i;

	i = search_MP3(fn, &file);
	if (i != fn){
		return -2;	// Ȃ
	}

	MusicSize = file.fsize;

	StopSw = 0;
	RewSw = 0;
	FfSw = 0;

	// t@CI[v
	if (f_open(&Mp3File, file.fname, FA_READ) != FR_OK)	return -5;

	if (music_p){
		// rĐ
		// tF[hC
		FadeInVol = Volume;
		Volume = 0xC0;		// ʂقڃ[
		set_volume(Volume);

		if (f_lseek(&Mp3File, music_p) != FR_OK)	return -6;
	}
	MusicP = music_p;

	// play_music_callback ^C}Zbg
	Timer = PLAY_MUSIC_CALLBACK_TIMER;	// 20msƂɌĂяo

	// t@Ce MP3fR[_ɂЂ]
	for (;;){
		uchar	buff[32];
		WORD	n;
		uchar	*p;
		char	r;

		if (f_read(&Mp3File, buff, 32, &n) != FR_OK){
			return -7;
		}
		WDR;
		set_volume(Volume);

		if (n == 0)	break;
		
		while (!VS_DREQ){	// VS1011 BUSY`FbN
			WDR;			// EHb`hbO^C}[Zbg
			SLEEP;			// sω荞ݑŋN
		}

		VS_DATA_ON;
		p = buff;
		for (i = 0; i < n; i++){
			SPI_out(*p++);
		}
		VS_DATA_OFF;

		MusicP += n;

		// R[obN֐ďo
		if (Timer == 0){
			Timer = PLAY_MUSIC_CALLBACK_TIMER;
			r = play_music_callback();
			if (r != 0){
				f_close(&Mp3File);
				return r;
			}
			check_batt();	// obe[`FbN
		}
	}
	f_close(&Mp3File);

	// [𑗂
	VS_DATA_ON;
	for (i = 0; i < 2048; i++){		// obt@TCY
		while (!MP3_DREQ){	// VS1011 BUSY`FbN
			WDR;			// EHb`hbO^C}[Zbg
		}
		SPI_out(0);
	}
	VS_DATA_OFF;

	// ĐI҂
	for (i = 0; i < 100 * 2; i++){
		WDR;
		SLEEP;
		SLEEP;
		if (MP3_command_read(SCI_HDAT0) != 0)	continue;
		if (MP3_command_read(SCI_HDAT1) == 0)	break;
	}

	return 0;
}


//*******************************************************
//	obe[d𒲂ׁAႷ΃Vbg_E
//*******************************************************
int check_batt(void){
	uint volt;

	cli();
	volt = BattVolt;
	sei();

	if (volt < BattLowShutDown){

		write_eeprom_word(32, volt);

		beep(4, BEEP_LOW);
		shutdown(0);	// Vbg_E
	}

	return volt;
}


//*********************************************************
//	Vbg_E
//	flag != 0 ̏ꍇ EEPROM݂s킸ɓd؂
//*********************************************************
void shutdown(char flag){

	WDR;

	set_volume(0xFF);	// ʃ[
	Timer = 5;
	while(Timer){
		SLEEP;
	}

	if (!flag){
		// EEPROMɐݒl
		write_eeprom(EEPROM_VOLUME, Volume);
		write_eeprom_word(EEPROM_MUSIC, PlayMusic);
		write_eeprom_long(EEPROM_MUSIC_P, MusicP);
		write_eeprom_long(EEPROM_SIZE, MusicSize);
	}

	// VS1011e AiOhCop[_E
	MP3_command(SCI_STATUS, MP3_command_read(SCI_STATUS)|SS_APDOWN2);
	
	// |bvmCYh߁AVS1011ẽAiOHp[_E܂ő҂
	Timer = 25;
	while(Timer){
		if (SwitchFlag){	//XCb`Ăꍇ͓dێ
			Timer = 25;		// XCb`ĂX 250ms҂
			WDR;
		}
		SLEEP;
	}

	cli();					// ݋֎~

	for (;;){
		PORTC &= ~(1<<POWER);	// POWERێ
		WDR;
	}
}


//*********************************************************
//	EEPROMyѐݒt@Cݒlǂݍ
//*********************************************************
void load_conf(void){
	FILINFO	fi;
	FIL	config;
	char	buff[32];
	uchar	c;
	WORD	n;
	uchar	i;
	DWORD	timestamp;
	DWORD	filetime;

	SleepTime = read_eeprom(EEPROM_SLEEP);
	if (SleepTime == 0xFF)	SleepTime = 30;	// X[v()
	VSclock = read_eeprom_long(EEPROM_VS_CLOCK);
	if (VSclock == 0xFFFFFFFF){
		VSclock = 24576000;		// 24.576MHz
		write_eeprom_long(EEPROM_VS_CLOCK, VSclock);
	}
	BattLowAlerm = read_eeprom_word(EEPROM_LOW_BATT);
	if (BattLowAlerm == 0xFFFF){
		BattLowAlerm = 503;	// 3.3V
	}
	BattLowShutDown = read_eeprom_word(EEPROM_SHUTDOWN);
	if (BattLowShutDown == 0xFFFF){
		BattLowShutDown = 473;	// 3.1V
	}

	// t@C EEPROM̃^CX^v̔r
	strcpy_P(buff, PSTR(CONFIG_FILE));
	if (f_stat(buff, &fi) != FR_OK)		return;		// t@CƂ
	filetime = ((DWORD)(fi.fdate) << 16)|(fi.ftime);
	timestamp = read_eeprom_long(EEPROM_CONF_TIMESTAMP);
	if (filetime == timestamp)			return;		//  t@C

	// ^CX^vقȂݒt@Ĉœǂݍ
	if (f_open(&config, buff, FA_READ) != FR_OK)	return;

	// 1ÂǂށBI[o[wbh傫Aŏ
	i = 0;
	while(f_read(&config, (void *)&c, 1, &n) == FR_OK){
		if (i == 0)	memset(buff, 0, sizeof(buff));
		if (n == 0)	break;	// Ō܂œǂ
		if (i >= (sizeof(buff) - 1)){
			// s܂œǂݔ΂
			if (c == LF)	i = 0;
			continue;
		}

		buff[i++] = c;
		if ((c == TAB)||(c == CR)||(c == LF)){
			strlwr(buff);	// S
			if (strncmp_P(buff, PSTR("init=yes"), 8) == 0){
				// EEPROMI[NA
				for (n = 0; n <= E2END; n++){
					write_eeprom(n, 0xFF);
				}
			} else if (strncmp_P(buff, PSTR("sleep="), 6) == 0){
				SleepTime = atoi(&buff[6]);
				write_eeprom(EEPROM_SLEEP, SleepTime);
			} else if (strncmp_P(buff, PSTR("batt-alerm="), 11) == 0){
				BattLowAlerm = atoi(&buff[11]);
				write_eeprom_word(EEPROM_LOW_BATT, BattLowAlerm);
			} else if (strncmp_P(buff, PSTR("batt-low="), 9) == 0){
				BattLowShutDown = atoi(&buff[9]);
				write_eeprom_word(EEPROM_SHUTDOWN, BattLowShutDown);
			}
			// s܂œǂݔ΂
			i = sizeof(buff);
		}
	}
	f_close(&config);

	// ݒ肪ÎŃt@C̃^CX^v EEPROMɏĂ
	write_eeprom_long(EEPROM_CONF_TIMESTAMP, filetime);
}

	
//*******************************************************
//	EEPROM 
//*******************************************************
void write_eeprom(uchar adrs, uchar data){

	// eȂ珑ݓsȂ
	if (read_eeprom(adrs) != data){
		while(EECR & (1<<EEPE));
		EEARH = (adrs >> 8);
		EEARL = adrs;
		EEDR = data;
		EECR |= (1<<EEMPE);
		EECR |= (1<<EEPE);
	}
}


//*******************************************************
//	EEPROM (ushort)
//*******************************************************
void write_eeprom_word(uint adrs, ushort data){

	write_eeprom(adrs++, data);
	write_eeprom(adrs, data>>8);
}


//*******************************************************
//	EEPROM (ulong)
//*******************************************************
void write_eeprom_long(uint adrs, ulong data){

	write_eeprom(adrs++, data);
	write_eeprom(adrs++, data>>8);
	write_eeprom(adrs++, data>>16);
	write_eeprom(adrs, data>>24);
}


//*******************************************************
//	EEPROM ǂݍ
//*******************************************************
uchar read_eeprom(uchar adrs){

	while(EECR & (1<<EEPE));
	EEARH = adrs >> 8;
	EEARL = adrs;
	EECR |= (1<<EERE);
	return EEDR;
}


//*******************************************************
//	EEPROM ǂݍ(ushort)
//*******************************************************
ushort read_eeprom_word(uint adrs){
	ushort data;

	data = (ulong)read_eeprom(adrs++);
	data |= (ulong)read_eeprom(adrs) << 8;

	return data;
}


//*******************************************************
//	EEPROM ǂݍ(ulong)
//*******************************************************
ulong read_eeprom_long(uint adrs){
	ulong data;

	data = (ulong)read_eeprom(adrs++);
	data |= (ulong)read_eeprom(adrs++) << 8;
	data |= (ulong)read_eeprom(adrs++) << 16;
	data |= (ulong)read_eeprom(adrs) << 24;

	return data;
}


//*********************************
//	ۂɃWX^삵ĉʐݒ
//*********************************
void set_volume(uchar vol){

	if (vol != VolumeReg){
		MP3_command(SCI_VOL, ((uint)vol << 8)|((uint)vol));	// ʐݒ
		VolumeReg = vol;
	}
}


//****************************************
//	BEEP
//	F	n	
//			err	!= 0 ȂG[(Ⴂ)
//	SLEEPĝŊ荞݋ŌĂяo
//****************************************
void beep(uchar n, char err){
	unsigned char	vol;

	MP3_init();
	
	MP3_command(SCI_MODE, SM_SDINEW|SM_TESTS);	// eXg[h
	MP3_wait();

	beep_wait(1);
	
#if BEEP_VOL_DIFF
	// {[
	vol = Volume + BEEP_VOL_DIFF;
	if (vol >= BEEP_VOL_DIFF){
		MP3_command(SCI_VOL, ((uint)vol << 8)|((uint)vol));	// ʐݒ
	} else {
		vol = 0;	// ʕύXȂ
	}
#endif

	// 30ms
	beep_wait(3);

	for (; n > 0; --n){
		if (err){
			MP3_sin(ErrorBeep);
		} else {
			MP3_sin(BeepData);
		}
		// ԑ҂B̊Ԃ BEEP̉̒ɂȂ
		beep_wait(10);	// 100ms

		MP3_sin(BeepStop);

		// BEEP̉ 30ms
		beep_wait(3);
	}

	// 100ms
	beep_wait(10);

	MP3_command(SCI_MODE, SM_SDINEW);			// SM_TEST=0
	MP3_wait();

#if BEEP_VOL_DIFF
	MP3_command(SCI_VOL, ((uint)Volume << 8)|((uint)Volume));	// ʐݒ
	MP3_wait();
#endif

	beep_wait(3);
}


//****************************************
//	beep()̎ԑ҂
//****************************************
void beep_wait(uchar n){

	BeepTimer = n;
	while(BeepTimer){
		SLEEP;
	}
}


//****************************************
//	VS1011 
//****************************************
void MP3_init(void){
	uint	val;

	// SPI}X^, CPOL=1, CPHA=1, Clock 8MHz/4=2MHz
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA);
	SPI_in();

	MP3_wait();

	MP3_command(SCI_MODE, SM_SDINEW|SM_RESET);			// Soft Reset
	MP3_wait();

	val = (uint)(VSclock / 2000L);	// Clock
	if ((val != 0)&&(val < 10000)){	// 20MHzȉȂ
		val |= 0x8000;	// NbN_uݒ
	}
	do {
		MP3_command(SCI_CLOCKF, val);
	} while(MP3_command_read(SCI_CLOCKF) != val);

	MP3_command(SCI_VOL, ((uint)Volume << 8)|((uint)Volume));	// ʐݒ

	for (val = 0; val < 20000; val++){
		NOP;
	}
}


//****************************************
// VS1011n[hEFAZbg
//****************************************
void VS1011_reset(void){

	VS_RESET_ON;
	SLEEP;
	VS_RESET_OFF;
	SLEEP;

	MP3_wait();
}


//****************************************
//	VS1011 eXgpgo
//****************************************
void MP3_sin(PGM_VOID_P data){
	uchar	i;
	uchar	c;

	VS_CTRL_OFF;
	VS_DATA_ON;

	for (i=0; i < 8; i++){
		SPI_out(0);
	}
	for (i=0; i < 8; i++){
		c = (uchar)pgm_read_byte(data++);
		SPI_out(c);
	}
	// ]Ƀ[𑗂 Ȃ STOPAςȂɂȂ邱Ƃ
	for (i=0; i < 8; i++){	// ͓KB炵ĂȂ
		SPI_out(0);
	}
	VS_DATA_OFF;
}


//****************************************
//	VS1011 R}hI҂
//****************************************
void MP3_wait(void){

	InitWait();
	while(!VS_DREQ);
}


//****************************************
//	VS1011 R}ho
//****************************************
void MP3_command(uchar addr, uint arg){

	MP3_wait();

	VS_DATA_OFF;
	VS_CTRL_ON;
	SPI_out(2);
	SPI_out(addr);
	SPI_out(arg >> 8);
	SPI_out(arg);
	VS_CTRL_OFF;
}


//****************************************
//	VS1011 R}h
//****************************************
uint MP3_command_read(uchar addr){
	uint	r = 0;

	while(!VS_DREQ);

	VS_CTRL_ON;
	SPI_out(3);
	SPI_out(addr);
	r = SPI_in() << 8;
	r |= SPI_in();
	VS_CTRL_OFF;
	return r;
}


//****************************************
//	̃NbNEGCg
//****************************************
void InitWait(void){
	uchar	i;

	for(i=0; i< 255; i++){
		NOP;
		NOP;
	}
}


//*********************************************************
//	A/DRo[^f[^
// ch :		A/D`l
// ߂l:	A/Dϊl(0`1023)
//*********************************************************
uint ADCin(char ch){
	uint	val;

	ADMUX = (1<<REFS1)|(1<<REFS0)|ch;	// d 1.1V, A/D ch
	ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);	// A/DϊHON vXP[ 7.3728MHz/64 = 115kHz

	ADCSRA |= (1<<ADSC);			// ϊJn

	while(!(ADCSRA&(1<<ADIF)));		// ADIF=1 ɂȂ܂Ń[v
	ADCSRA |= (1<<ADIF);			// ADIFNA(1ƃNA)

	val = (uint)ADCL;	
	return (((uint)ADCH)<<8)|val;
}


//*********************************************************
//	XCb`mɕ܂ő҂
//*********************************************************
void switch_wait(void){

	sei();
	for (;;) {
		WDR;
		SLEEP;
		SLEEP;
		if (!(SwitchFlag & ((1<<SW_FF)|(1<<SW_STOP)|(1<<SW_REW)))){
			SLEEP;
			SLEEP;
			if (!(SwitchFlag & ((1<<SW_FF)|(1<<SW_STOP)|(1<<SW_REW)))){
				break;
			}
		}
	}
}


//****************************************
//	MMC/SD SPIR}ho
//****************************************
uchar SPI_command(uchar com, ulong arg){
	uint	i;
	uchar	r;

	// BUSY`FbN
	for (i = 0; i < 30000; i++){
		r = SPI_in();
		if (r == 0xFF)	break;
	}
	if (r != 0xFF)	return 1;

	SPI_out(com|0x40);
	SPI_out(arg >> 24);
	SPI_out(arg >> 16);
	SPI_out(arg >> 8);
	SPI_out(arg);
	SPI_out(0x95);	// R}hCRC

	// R1҂
	for (i = 0; i < 2000; i++){
		r = SPI_in();
		if (r != 0xFF)	break;
	}

	return r;
}


//****************************************
//	SPIf[^o
//****************************************
void SPI_out(uchar data){

	SPDR = data;
	while(!(SPSR & (1<<SPIF)));
}


//****************************************
//	SPIf[^
//****************************************
uchar SPI_in(void){

	SPDR = 0xFF;
	while(!(SPSR & (1<<SPIF)));
	return SPDR;
}



//*****************************************************************
//	Low Level routine for Tiny-FatFs
//*****************************************************************

static volatile
DSTATUS Stat[1] = {STA_NOINIT};	/* Disk status */

//****************************************
// fBXN
//****************************************
DSTATUS disk_initialize(BYTE drive){
	uchar	c;

	if (drive)	return STA_NOINIT;
	
	// J[h̗L͂킩Ȃ

	if (!(Stat[drive] & STA_NODISK)){

		Stat[drive] = STA_NOINIT;
	
		// SPI}X^, CPOL=1, CPHA=1, Clock 8MHz/64=125kHz
		SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA)|(1<<SPR1);

		// CS = H
		MMC_CS_OFF;

		// MMC/SD SPI[hڍsÕNbNM
		for (c = 0; c < 20; c++){
			SPI_in();
		}

		// SPI[hڍsR}h
		WDR;
		MMC_CS_ON;		// CS=L
		c = SPI_command(0, 0);
		while ((c != 1)&&(c != 0xFF)){
			c = SPI_command(0, 0);
			SLEEP;
		}
		while (c == 1){
			c = SPI_command(1, 0);
			SLEEP;
		}
		MMC_CS_OFF;		// CS=H
		SPI_in();

		// SPI Clock 8MHz/4=2MHz
		SPCR &= ~(1<<SPR1);
		SPSR |= (1<<SPI2X);	// SPINbN 4MHz

		if (c != 0){
			Stat[drive] = STA_NODISK|STA_NOINIT;
			return Stat[drive];
		}

		Stat[drive] &= ~STA_NOINIT;

		// CgveNgo

	}
	return Stat[drive];	
}


//****************************************
// fBXNԎ擾
//****************************************
DSTATUS disk_status(BYTE drive){

	if (drive)	return STA_NOINIT;

	// J[h̗L͂킩Ȃ
	// CgveNg킩Ȃ
	
	return Stat[drive];	
}


//****************************************
// fBXNǂݍ
//****************************************
DRESULT disk_read(BYTE drive, BYTE *buffer, DWORD sectorNumber, BYTE sectorCount){
	uint	i;
	uchar	r;

	if (drive || !sectorCount) return RES_PARERR;
	if (Stat[drive] & STA_NOINIT)	return RES_NOTRDY;

	if (disk_status(drive) & (STA_NODISK|STA_NOINIT))	return RES_NOTRDY;

	sectorNumber *= 512;
	
	WDR;
	while(sectorCount > 0){

		MMC_CS_ON;	// CS=L
		SPI_in();

		r = SPI_command(17, sectorNumber);
		if (r == 0){
			for (i = 0; i < 30000; i++){	// ̂҂ꍇ
				r = SPI_in();
				if (r == 0xFE){
					break;		// ]Jn}[N
				}
			}
		}

		if (r != 0xFE){
			r = 1;
			goto QUIT;		// ERROR
		} else {
			r = 0;
		}

		for (i = 0; i < 512; i++){
			*buffer++ = SPI_in();
		}

		SPI_in();	// CRC
		SPI_in();	// CRC

	  QUIT:
		MMC_CS_OFF;	// CS=H
		SPI_in();

		if (r)	return RES_ERROR;
		
		sectorNumber += 512;
		--sectorCount;
	}

	return RES_OK;
}


//****************************************
// fBXN
//****************************************
DRESULT disk_write(BYTE drive, const BYTE *buffer, DWORD sectorNumber, BYTE sectorCount){

#if _FS_READONLY == 0

	uint	i;
	uchar	r = 0;

	if (drive || !sectorCount) return RES_PARERR;
	if (Stat[drive] & STA_NOINIT) return RES_NOTRDY;
	if (Stat[drive] & STA_PROTECT) return RES_WRPRT;

	WDR;
	while(sectorCount > 0){
		MMC_CS_ON;	// CS=L
		SPI_in();

		// BUSY`FbN
		MMCtimer = MMC_WAIT;
		while(MMCtimer){
			r = SPI_in();
			if (r == 0xFF)	break;
		}
		if (r != 0xFF){
			r = 1;
			goto QUIT;
		}

		r = 1;
		if (SPI_command(24, sectorNumber << 9) == 0){	// ݃R}h
			SPI_out(0xFE);	// X^[gubN
			for (i = 0; i < 512; i++){
				SPI_out(*buffer++);
			}
			SPI_in();	// CRCAĂ
			SPI_in();

			// X|XM
			for (i = 0; i < 3000; i++){
				r = SPI_in() & 0x1F;
				if ((r & 0x11) == 0x01)	break;
			}

			if (r == 0x05){
				r = 0;	// ɏ߂͂
			} else {
				r = 1;	// ݃G[
			}
		}
	  QUIT:	
		MMC_CS_OFF;	// CS=H
		SPI_in();

		if (r)	return RES_ERROR;

		sectorNumber++;
		--sectorCount;
	}

#endif
	return RES_OK;
}


//****************************************
// fBXN ioctl
//****************************************
DRESULT disk_ioctl(BYTE drive, BYTE command, void *buffer){
	uchar	r;
	BYTE csd[16];
	WORD csm, csize;
	uint i;

	WDR;
	if (disk_status(drive) & STA_NOINIT) return RES_NOTRDY;

	switch(command){
	  case GET_SECTOR_COUNT:

		MMC_CS_ON;	// CS=L
		r = SPI_command(9, 0);
		if (r == 0){
			for (i = 0; i < 1000; i++){	// ҂
				r = SPI_in();
				if (r == 0xFE){
					break;		// ]Jn}[N
				}
			}
		}

		if (r != 0xFE){
			r = RES_ERROR;
			goto QUIT;		// ERROR
		}

		for (i = 0; i < 16; i++){
			csd[i] = SPI_in();
		}

		SPI_in();	// CRC
		SPI_in();	// CRC

		csm = ((csd[10] & 128) >> 7) + ((csd[9] & 3) << 1) + 2;
		csize = ((csd[8] & 0xC0) >> 6) + ((WORD)csd[7] << 2) + ((WORD)(csd[6] & 3) << 10) + 1;
		*(DWORD*)buffer = (DWORD)csize << csm;
		r = RES_OK;
	  QUIT:
		MMC_CS_OFF;	// CS=H
		SPI_in();
		return r;

	  case CTRL_SYNC:
		MMC_CS_ON;	// CS=L
		SPI_in();
		MMCtimer = MMC_WAIT;
		r = RES_ERROR;
		while(MMCtimer){
			if (SPI_in() == 0xFF){
				r = RES_OK;
				break;
			}
		}
		MMC_CS_OFF;	// CS=H
		SPI_in();
		return r;

	  default:
		return RES_PARERR;
	}
}


//****************************************
// ^CX^v擾
//****************************************
DWORD get_fattime(void){

	return 0;
}
